//
//  RASound.h
//  rayne-openal
//
//  Created by Sidney Just on 23.08.13.
//  Copyright (c) 2013 Sidney Just. All rights reserved.
//

#ifndef __rayne_openal__RASound__
#define __rayne_openal__RASound__

#include <Rayne.h>

namespace RN
{
	namespace openal
	{
		class Source;
		class Sound : public Object
		{
		public:
			friend class Source;
			
			enum class Type
			{
				Stream,
				Static
			};
			
			Sound(const std::string& file, Type type);
			~Sound() override;
			
			static Sound *WithFile(const std::string& file, Type type);
			
			void PreLoad();
			bool IsLoaded() const;
			Type GetType() const { return _type; }
			
		private:
			Type _type;
			void *_internal;
			
			RNDefineMeta(Sound, Object)
		};
	}
}

#endif /* defined(__rayne_openal__RASound__) */
